apiVersion: apps/v1
kind: StatefulSet
metadata:
  name: clinical-data-service-db
spec:
  serviceName: clinical-data-service-db
  selector:
    matchLabels:
      app: clinical-data-service-db
  template:
    metadata:
      labels:
        app: clinical-data-service-db
    spec:
      containers:
        - name: clinical-data-service-db
          image: postgres:14.1-bullseye
          args: ["-c", "config_file=/etc/postgresql/postgresql.conf"]
          ports:
            - containerPort: 5432
          volumeMounts:
            - name: postgres-config
              mountPath: /etc/postgresql/postgresql.conf
              subPath: postgresql.conf
            - name: postgresql-db-disk
              mountPath: /var/lib/postgresql/data
            - name: init-script-dir
              mountPath: /docker-entrypoint-initdb.d
          env:
            - name: POSTGRES_PASSWORD
              valueFrom:
                secretKeyRef:
                  name: clinical-data-service-db
                  key: POSTGRES_PASSWORD
            - name: CLINICAL_DATA_SERVICE_PASS
              valueFrom:
                secretKeyRef:
                  name: clinical-data-service-db
                  key: CLINICAL_DATA_SERVICE_PASS
            - name: METABASE_CLIENT_PASS
              valueFrom:
                secretKeyRef:
                  name: clinical-data-service-db
                  key: METABASE_CLIENT_PASS
            - name: MB_DB_PASS
              valueFrom:
                secretKeyRef:
                  name: clinical-data-service-db
                  key: MB_DB_PASS
      initContainers:
      - name: database-init-scripts
        image: registry.gitlab.com/greece-vs-corona/deployment/clinical-data-service-db-init:1.0.1
        volumeMounts:
          - name: init-script-dir
            mountPath: /init-script-dir
      volumes:
        - name: init-script-dir
          emptyDir: {}
        - name: postgres-config
          configMap:
            name: clinical-data-service-db-conf
  volumeClaimTemplates:
    - metadata:
        name: postgresql-db-disk
      spec:
        accessModes: ["ReadWriteOnce"]
        resources:
          requests:
            storage: 5Gi
